/// <reference types="socket.io-client" />
import { CLIENT, CLIENTS, EVENT_TYPE } from "epic-chat-helper";
export declare type HTMLTemplateVariables = {
    [key: string]: string | null;
};
export declare type HTMLTemplate = {
    [key: string]: string;
};
export declare type HTMLElements = {
    [key: string]: HTMLElement;
};
export declare type HTMLAppends = {
    id: string;
    htmlSelector: string;
    htmlTemplateString: string;
};
export declare class epicChatHelper {
    protected url: string;
    protected socket: SocketIOClient.Socket | null;
    protected currentContact: CLIENT;
    protected contactList: string[];
    protected connectionCount: number;
    protected connections: CLIENTS;
    protected me: CLIENT | null;
    protected eventPrefix: string;
    protected traceUrl: string;
    protected traceHandler: Function;
    protected trace: any;
    protected templateVariables: HTMLTemplateVariables;
    protected parentElement: HTMLElement | null;
    protected childTemplate: HTMLTemplate;
    protected childTemplateProcessed: HTMLTemplate;
    protected childElements: HTMLElements;
    protected templateRendered: boolean;
    protected appends: HTMLAppends[];
    connectionsUpdate?: Function;
    connectionAdded?: Function;
    connectionRemoved?: Function;
    constructor();
    init: (contactList: string[], uri: string, connectOptions?: SocketIOClient.ConnectOpts | undefined) => this;
    connect: (connected: Function, connectionError?: Function | undefined) => this;
    traceConfig: (traceUrl: string, traceHandler: Function) => this;
    authenticate: (reference: string | null, name: string | null, contact: string | null, meta?: any) => Promise<unknown>;
    sendMessage: (message: string, reference?: string | undefined) => this;
    receiveMessage: (callback: Function) => this;
    typing: (text: string) => this;
    onTyping: (callback: Function) => this;
    sendEvent: (payload: any, type?: EVENT_TYPE, receiver?: CLIENT | undefined) => this;
    receiveEvent: (callback: Function) => this;
    addContact: (reference: string) => this;
    setContact: (reference: string) => this;
    getContact: (reference: string) => CLIENT;
    getCurrentContact: () => CLIENT;
    templateSetParent: (htmlSelector: string) => this;
    templateGetParent: () => HTMLElement;
    templateSelect: (elementName: string, htmlSelector: string, htmlTemplateString?: string, templateVariables?: HTMLTemplateVariables) => this;
    templateAppend: (appendId: string, htmlSelector: string, htmlTemplateString?: string, templateVariables?: HTMLTemplateVariables, render?: boolean, rendered?: Function | undefined) => this;
    removeAppendById: (appendId: string) => this;
    removeAppendByParent: (htmlSelector: string) => this;
    clearAppend: () => this;
    putVariables: (template: string) => string;
    processTemplate: () => this;
    renderTemplate: (rendered?: Function | undefined, rendering?: Function | undefined) => this;
    renderAppend: (renderLast?: boolean, clear?: boolean) => this;
    updateTemplateVariables: (templateVariables: HTMLTemplateVariables, render?: boolean, rendered?: Function | undefined) => this;
}
//# sourceMappingURL=epicChatHelperClient.d.ts.map